\version "2.20.0"

#(define (articulationEvent event articulation property)
  (set! (ly:music-property event property)
        (append
          (ly:music-property event property)
          `(,(make-music 'ArticulationEvent 'articulation-type articulation)))))

% Example \addArticulation staccato { r4 a b c }
addArticulation =
#(define-music-function (articulation music) (symbol? ly:music?)
  (let* ((a (symbol->string articulation)))
    (map-some-music
      (lambda (m)
        (case (ly:music-property m 'name)
          ((NoteEvent)  (articulationEvent m a 'articulations) m)
          ((EventChord) (articulationEvent m a 'elements)      m)
          ((GraceMusic) m)
          (else #f)))
      music)))

#(define (tremoloEvent event duration property)
  (set! (ly:music-property event property)
        (append
          (ly:music-property event property)
          `(,(make-music 'TremoloEvent 'tremolo-type duration)))))

addTremolo =
#(define-music-function (d music) (integer? ly:music?)
    (map-some-music
      (lambda (m)
        (case (ly:music-property m 'name)
          ((NoteEvent)  (tremoloEvent m d 'articulations) m)
          ((EventChord) (tremoloEvent m d 'elements)      m)
          (else #f)))
      music))

#(if (and (<= (first (ly:version)) 2) (<= (second (ly:version)) 20))
  (define slashturn
  #{
    \markup \combine
    \translate #'(0.65 .  0.0) \musicglyph "scripts.turn"
    \translate #'(0.0  . -0.7) "|"
  #}))

#(define slashturnsharp
 (if (and (<= (first (ly:version)) 2) (<= (second (ly:version)) 20))
  #{
    \markup \override #'(baseline-skip . 2.5) \halign #-0.5 \center-column { \slashturn \tiny \sharp }
  #}
  #{
    \markup \override #'(baseline-skip . 2.5) \halign #-0.5 \center-column { \musicglyph #"scripts.slashturn" \tiny \sharp }
  #})
)

#(define slashturnflat
 (if (and (<= (first (ly:version)) 2) (<= (second (ly:version)) 20))
  #{
    \markup \override #'(baseline-skip . 2.5) \halign #-0.5 \center-column { \slashturn \tiny \flat }
  #}
  #{
    \markup \override #'(baseline-skip . 2.5) \halign #-0.5 \center-column { \musicglyph #"scripts.slashturn" \tiny \flat }
  #})
)

#(define slashturnnatural
 (if (and (<= (first (ly:version)) 2) (<= (second (ly:version)) 20))
  #{
    \markup \override #'(baseline-skip . 2.5) \halign #-0.5 \center-column { \slashturn \tiny \natural }
  #}
  #{
    \markup \override #'(baseline-skip . 2.5) \halign #-0.5 \center-column { \musicglyph #"scripts.slashturn" \tiny \natural }
  #})
)

beaming = #(define-music-function (division) (list?)
  #{ \set Timing.beatStructure = #division #} )

ficta = {
  \once \set suggestAccidentals = ##t
  % print second & subsequent accidentals in a bar
  \once \accidentalStyle "dodecaphonic"
}

pizz = \markup "pizz."
arco = \markup "arco"
mute = \markup "con sordini"
nomute = \markup "senza sordini"
soli = \markup \bold "Soli"
